/**
 * linkStates-objekte speichern in einer hashMap zu jedem knoten eine
 * hashMap, die zu jedem knoten die distanz enthaelt
 * etwa so:
 * a, ( (a,0), (b,4), (c,2), (d,1000000) )
 * b, ( (a,4), (b,0), (c,3), (d,1)  )
 * usw.
 *
 */
package dijkstra;

import java.util.HashMap;
import java.util.Set;  // ein set ist eine liste

class LinkStates {

    HashMap<String, HashMap<String, Integer>> matrix;
    HashMap<String, Integer> zeile;

    //link-state hinzufuegen:
    public void addLinkState(String startKnoten, String nachbar, int distanz) {
        //zuerst pruefen, ob es schon eine datenstruktur gibt
        //wenn nein, legen wir eine neue, leere an
        if (matrix == null) {
            matrix = new HashMap();
        }

        //dann wird geprueft, ob es schon einen eintrag zum
        //startknoten gibt
        if (matrix.containsKey(startKnoten)) {
            zeile = matrix.get(startKnoten);
        } else {
            zeile = new HashMap();
        }

        zeile.put(nachbar, distanz);
        matrix.put(startKnoten, zeile);

    }

    public Set<String> getNachbarn(String knoten) {

        return null;
    }

    public Set<String> getAlleKnoten() {
        return null;
    }

    public int getDistanz(String u, String v) {
        return 0;
    }

    public void matrixDrucken() {
        System.out.println(matrix.toString());

        //das ganze zu fuss (mit der hand am arm):
        //erstmal holen wir die liste mit den keys der matrix
        Set<String> knotenListe = matrix.keySet();
        for (String element : knotenListe) {
            zeile = matrix.get(element);
            Set<String> nachbarListe = zeile.keySet();
            System.out.printf("%s\t",
                    element
            );
            for (String nachbar : nachbarListe) {
                System.out.printf("%s|%s\n\t",
                        nachbar,
                        zeile.get(nachbar)
                );
            }
            System.out.printf("\n");

        }

    }

    public LinkStates() {
        this.addLinkState("a", "b", 4);
        this.addLinkState("b", "a", 4);
        this.addLinkState("b", "c", 3);
        this.addLinkState("b", "d", 1);
        this.addLinkState("a", "c", 2);
        this.addLinkState("c", "a", 2);
        this.addLinkState("c", "b", 1);
        this.addLinkState("c", "d", 5);
        this.addLinkState("d", "b", 1);
        this.addLinkState("d", "c", 5);

        this.matrixDrucken();
    }

    public static void main(String[] args) {
        new LinkStates();
    }
}
